import 'dart:math' as math;
import 'package:fis_measure/utils/number.dart';

class CardiacFormulas {
  CardiacFormulas._();

  /// <summary>
  /// IMP=(CO-ET)/ET
  /// </summary>
  /// <param name="co">s</param>
  /// <param name="et">s</param>
  /// <returns>(unit None)</returns>
  static double teiIndex(double co, double et) {
    double imp = 0.0;
    if (et != 0.0) {
      imp = (((co).abs() - (et).abs()) / et).abs();
    }
    return imp;
  }
}
