import 'dart:async';

Map<String, Timer> _funcThrottle = {};
Function? _lastFunc;

/// 函数节流
///
/// [func]: 要执行的方法
/// [funcTag]: 方法标识符
/// [milliseconds]: 要迟延的毫秒时间
Function throttle(Function func, String funcTag, [int milliseconds = 2000]) {
  target() {
    String key = funcTag.toString();
    Timer? _timer = _funcThrottle[key];
    if (_timer == null) {
      func.call();
      _timer = Timer(Duration(milliseconds: milliseconds), () {
        final lastFunc = _lastFunc;
        if (lastFunc != null) {
          _lastFunc!.call();
          _lastFunc = null;
        }
        Timer? t = _funcThrottle.remove(key);
        t?.cancel();
        t = null;
      });
      _funcThrottle[key] = _timer;
    } else {
      _lastFunc = func;
    }
  }

  target();

  return target;
}
